//NINA_graphe_504f.js
//Une extension du script "NINA.jsx" par Olav Martin Kvern
// 12.04.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Dessine un objet dcoratif et geomtrique

//For more on NINA, see http://www.washington.edu/bibsys/mattf/nina/index.html

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// mmoriser la version de l'application
var appVers = (app.version[0])*1;

// dfinir les noms des nuances fixes
noColor    = "[None]";
regisColor = "[Registration]";
paperColor = "[Paper]";
blackColor = "[Black]";

// mmoriser la langue du programme
var curLang = (app.locale)*1;

// prparer les noms des nuances (en FR et DE)
if (curLang   == 1279477362) { // = franais
	noColor      = "[Sans]";
	regisColor   = "[Registration]";
	paperColor   = "[Papier]";
	blackColor   = "[Noir]";
	if (appVers == 4) {
		noColor    = "[Aucun]";
		regisColor = "[Registration]";
	}
}
else if (curLang == 1279477613) { // = allemand
	noColor      = "[Ohne]";
	regisColor   = "[Passermarken]";
	paperColor   = "[Papier]";
	blackColor   = "[Schwarz]";
	if (appVers == 4) {
		noColor    = "[Keine]";
		regisColor = "[Passkreuze]";
	}
}

// la partie principale du script
if (app.documents.length != 0) {
	if (app.activeWindow.constructor.name == "LayoutWindow") {
		var curDoc = app.documents[0];
		// dresser une liste des nuances
		allSwatches = curDoc.swatches;
		// appeler la fonction qui lit les prfrences mmorises
		var allPrefs = getPrefs();
		if (allPrefs != "") {
			var prefVal = allPrefs.split("\n");
			var xPos  = prefVal[0]*1;
			var yPos  = prefVal[1]*1;
			var curD  = prefVal[2]*1;
			var nPts  = prefVal[3]*1;
			var aPls  = prefVal[4]*1;
			var bPls  = prefVal[5]*1;
			var bName = prefVal[6];
			if      (bName == "Black") { bName = blackColor; }
			else if (bName == "Paper") { bName = paperColor; }
			else if (bName == "Registration") { bName = regisColor; }
			else if (bName == "None") { bName = noColor; }
			var bgrT  = prefVal[7]*1;
			var ck0   = false;
			var eoFll = prefVal[8];
			if (eoFll == "true") {
				ck0 = true;
			}
			var sName = prefVal[9];
			if      (sName == "Black") { sName = blackColor; }
			else if (sName == "Paper") { sName = paperColor; }
			else if (sName == "Registration") { sName = regisColor; }
			else if (sName == "None") { sName = noColor; }
			var strT  = prefVal[10]*1;
			var strW  = prefVal[11]*1;
			var alig  = prefVal[12];
			var ck1 = 1;
			var ck2 = 0;
			var ck3 = 0;
			if (alig == "1") {
				ck1 = 0;
				ck2 = 1;
			}
			else if (alig == "2") {
				ck1 = 0;
				ck3 = 1;
			}
		}
		else {
			// utiliser les valeurs par dfaut 
			// quand le fichier des prfrences n'existe pas
			var xPos =   100;
			var yPos =   100;
			var curD =    50;
			var nPts =   201;
			var aPls =    16;
			var bPls =   161;
			var bgrT =    70;
			var ck0  = false;
			var strT =   100;
			var strW =   0.5;
			var ck1  =     1;
			var ck2  =     0;
			var ck3  =     0;
			var bName = noColor;
			var sName = blackColor;
		}
		
		// appeler les fonctions qui prparent les listes des couleurs
		var bgrColor = getBgrColorList(bName);
		var bgrCol   = bgrColor[0];
		var bInd     = bgrColor[1];
		var strColor = getStrColorList(sName);
		var strCol   = strColor[0];
		var sInd     = strColor[1];
		
		// mmoriser les units de mesure
		// si ce n'est pas 2053991795 (= millimtres), modifier  millimtres
		hM = curDoc.viewPreferences.horizontalMeasurementUnits;
		vM = curDoc.viewPreferences.verticalMeasurementUnits;
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
		}
		// mettre l'origine des repres  "Page"
		var rO = curDoc.viewPreferences.rulerOrigin;
		if (rO != 1380143215) {
			curDoc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;
		}
		
		// mettre le point zro  zro/zro
		var zP = curDoc.zeroPoint; 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = [0,0]; 
		}
		
		// appeler la fonction qui affiche le dialogue
		var anArray = displayDialog(xPos, yPos, curD, nPts, aPls, bPls, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3);
		var centerPoint = anArray[0];
		var xPos        = centerPoint[0];
		var yPos        = centerPoint[1];
		var curDiameter = anArray[1];
		var numOfLines  = anArray[2];
		var aPulse      = anArray[3];
		var bPulse      = anArray[4];
		var bColor      = anArray[5];
		var bgrT        = anArray[6];
		var evenOddFill = anArray[7];
		var sColor      = anArray[8];
		var strT        = anArray[9];
		var strW        = anArray[10];
		var strA        = anArray[11];
		// appeler la fonction qui dessine la NINA
		drawNINA(xPos, yPos, curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, evenOddFill, sColor, strT, strW, strA);
		
		// restaurer le point zro (si ncessaire)
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		
		// restaurer l'origine des rgles (si ncessaire)
		if (rO != 1380143215) {
			curDoc.viewPreferences.rulerOrigin = rO;
		}
		
		// restaurer les units de mesure (si ncessaire)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// passer le mode de l'cran  "Aperu
		if (appVers > 4) {
			app.activeWindow.screenMode = ScreenModeOptions.PREVIEW_TO_PAGE;
		}
	}
}
else {
	alert ("Ouvrir un document, s.v.p.", "Stop");
}


///////////// LES FONCTIONS ///////////////////////////////////////

// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les rglages mmoriss
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGraphe504.txt");
	}
	else {
		var f = new File("~/Library/Preferences/NinaGraphe504.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// la fonction qui prpare la liste des couleurs pour le fond
function getBgrColorList(bName) {	
	// vrifier si la couleur mmorise existe
	if (bName != noColor && bName != regisColor && bName != paperColor && bName != blackColor) {
		try {
			curDoc.swatches.itemByName(bName).name;
		}
		catch (e) {
			bName = blackColor;
		}
	}
	
	// assembler la liste des couleurs;
	// renommer "None", "Paper", "Black" et "Registration";
	// relever la position de la couleur mmorise
	var bgrColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (bName == cName) {
			bIndex = i;
		}
		bgrColorList.push(cName);
	}
	return [bgrColorList, bIndex];
}

// la fonction qui prpare la liste des couleurs du contour
function getStrColorList(sName) {
	// vrifier si la couleur mmorise existe
	if (sName != noColor && sName != regisColor && sName != paperColor && sName != blackColor) {
		try {
			curDoc.swatches.itemByName(sName).name;
		}
		catch (e) {
			sName = blackColor;
		}
	}
	
	// assembler la liste des couleurs;
	// renommer "None", "Paper", "Black" et "Registration";
	// relever la position de la couleur mmorise
	var strColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (sName == cName) {
			sIndex = i;
		}
		strColorList.push(cName);
	}
	return [strColorList, sIndex];
}

// prparer et afficher le dialogue
function displayDialog(xPos, yPos, curD, nPts, aPls, bPls, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 115;
	var fieldWidth =  40;
	var aDialog = app.dialogs.add({name:"NINA_graphe"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Le centre", minWidth:labelWidth-25});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"X:"});
			}
			with (dialogColumns.add()) {
				var xField = realEditboxes.add({editValue:xPos, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"", minWidth:labelWidth-25});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Y:"});
			}
			with (dialogColumns.add()) {
				var yField = realEditboxes.add({editValue:yPos, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Longueur de filet", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var curDiameterField = realEditboxes.add({editValue:curD, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Nombre de points", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var nPointsField = integerEditboxes.add({editValue:nPts, minWidth:fieldWidth});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Amplitude A", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var APulseField = integerEditboxes.add({editValue:aPls,minWidth:fieldWidth});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Amplitude B", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var BPulseField = integerEditboxes.add({editValue:bPls, minWidth:fieldWidth});
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le fond de l'objet", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var bgrColor = dropdowns.add({stringList:bgrCol, selectedIndex:bInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"La teinte", minWidth:labelWidth-10});
					var bgrTint = realEditboxes.add({editValue:bgrT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
			}
		}
		var evenOddCheckbox = checkboxControls.add({staticLabel:"Remplissage altern", checkedState:ck0});
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le contour de l'objet", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var strColor = dropdowns.add({stringList:strCol, selectedIndex:sInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"La teinte", minWidth:labelWidth-10});
					var strTint = realEditboxes.add({editValue:strT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"L'paisseur", minWidth:labelWidth-10});
					var strWeight = realEditboxes.add({editValue:strW, minimumValue:0, maximumValue:5, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"pt", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"L'alignement", minWidth:labelWidth-10});
					with(aligButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"centrer",   checkedState:ck1});
						radiobuttonControls.add({staticLabel:"intrieur", checkedState:ck2});
						radiobuttonControls.add({staticLabel:"extrieur", checkedState:ck3});
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		var x = xField.editValue;
		var y = yField.editValue;
		var curDiameter = curDiameterField.editValue;
		var numOfLines  = nPointsField.editValue;
		var aPulse = APulseField.editValue;
		var bPulse = BPulseField.editValue;
		bgrIndex = bgrColor.selectedIndex;
		bColor = curDoc.swatches[bgrIndex].name;
		if      (bColor == blackColor) { bColor = "Black"; }
		else if (bColor == paperColor) { bColor = "Paper"; }
		else if (bColor == regisColor) { bColor = "Registration"; }
		else if (bColor == noColor)    { bColor = "None"; }
		bgrT = bgrTint.editValue;
		var ck0 = evenOddCheckbox.checkedState;
		strIndex = strColor.selectedIndex;
		sColor = curDoc.swatches[strIndex].name;
		if      (sColor == blackColor) { sColor = "Black"; }
		else if (sColor == paperColor) { sColor = "Paper"; }
		else if (sColor == regisColor) { sColor = "Registration"; }
		else if (sColor == noColor)    { sColor = "None"; }
		strT = strTint.editValue;
		strW = strWeight.editValue;
		var aligDec = aligButtons.selectedButton;
		if (aligDec == 0) {
			strA = 1936998723; // centrer
		}
		else if (aligDec == 1) {
			strA = 1936998729; // intrieur
		}
		else if (aligDec == 2) {
			strA = 1936998735; // extrieur
		}
		aDialog.destroy();
		var prefsList = new Array (x, y, curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, ck0, sColor, strT, strW, aligDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		if (ck0 == true && numOfLines%2 == 0) {
			alert ("Le nombre de points doit tre un chiffre *impair*, afin de pouvoir appliquer le remplissage altern.", "Attention");
			exit();
		}
		return [[x, y], curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, ck0, sColor, strT, strW, strA];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGraphe504.txt");
	}
	else {
		var f = File("~/Library/Preferences/NinaGraphe504.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// cette fonction dessine la NINA
function drawNINA(xPos, yPos, curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, ck0, sColor, strT, strW, strA) {
	var cur_x, cur_y;
	var aAnchor = new Array(2);
	var arr = new Array(numOfLines);
	// au lieu de placer point par point, la liste "arr" est remplie avec une srie de 
	// coordonnes et toutes les positions de points sont appliques  l'aide de "entirePath"
	for (var ctr = 0; ctr < numOfLines; ctr++) {
		cur_x = ((Math.cos((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.cos((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + xPos;
		cur_y = ((Math.sin((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.sin((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + yPos;
		aAnchor = [cur_x, cur_y];
		arr[ctr] = aAnchor;
	}
	with (curDoc){
		var curPage = app.activeWindow.activePage;
		var isLocked = false;
		var curLayer = app.activeWindow.activeLayer;
		if (curLayer.locked == true) {
			curLayer.locked = false;
			var isLocked = true;
		}
		with (curPage) {
			var newLine = graphicLines.add();
			newLine.strokeWeight = strW;
			var curPath = newLine.paths.item(0);
			// appliquer le contenu de la liste au chemin
			curPath.entirePath = arr;
			curPath.pathType = PathType.closedPath;
			// appliquer les couleurs
			if (ck0 == true) {
				var newPolygon = newLine.duplicate();
				try {
					newLine.addPath(newPolygon);
				}
				catch (e) {
				}
				newPolygon.properties = {fillColor:bColor, fillTint:bgrT, strokeWeight:strW, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA};
				// crire les rglages NINA dans l'tiquette de l'objet
				newPolygon.label = "Longueur du filet: " + curDiameter + " mm\rNombre de points:: " + numOfLines + "\rAmplitude A: " + aPulse + "\rAmplitude B: " + bPulse;
			}
			else {
				newLine.properties = {fillColor:bColor, fillTint:bgrT, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA};
				// crire les rglages NINA dans l'tiquette de l'objet
				newLine.label = "Longueur du filet: " + curDiameter + " mm\rNombre de points:: " + numOfLines + "\rAmplitude A: " + aPulse + "\rAmplitude B: " + bPulse;
			}
		}
		if (isLocked) {
			curLayer.locked = true;
		}
	}
}